--
--create table RECHERCHE.NOMENCLATURE_CATEGORIES
--(
--  NC_ORDRE NUMBER NOT NULL,
--  NC_CODE VARCHAR2(20) NOT NULL,
--  NC_LIBELLE VARCHAR2(50) NOT NULL,
--  NC_PERS_ID_CREATION NUMBER NOT NULL,
--  NC_PERS_ID_MODIFICATION NUMBER NOT NULL,
--  NC_D_CREATION DATE NOT NULL,
--  NC_D_MODIFICATION DATE NOT NULL 
--);
--
--ALTER TABLE RECHERCHE.NOMENCLATURE_CATEGORIES ADD (PRIMARY KEY (NC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);
--
--ALTER TABLE RECHERCHE.NOMENCLATURE_CATEGORIES ADD (
--  CONSTRAINT FK_NC_PERSID_CREATION 
--  FOREIGN KEY (NC_PERS_ID_CREATION) 
--  REFERENCES GRHUM.PERSONNE (PERS_ID) DEFERRABLE INITIALLY DEFERRED
--);
--
--ALTER TABLE RECHERCHE.NOMENCLATURE_CATEGORIES ADD (
--  CONSTRAINT FK_NC_PERSID_MODIFICATION 
--  FOREIGN KEY (NC_PERS_ID_MODIFICATION) 
--  REFERENCES GRHUM.PERSONNE (PERS_ID) DEFERRABLE INITIALLY DEFERRED
--);

CREATE SEQUENCE RECHERCHE.NOMENCLATURE_NOMENCLATURES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.NOMENCLATURE_OBJETS_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;

GRANT SELECT ON GRHUM.COMPTE TO RECHERCHE;
GRANT SELECT ON GRHUM.GRHUM_PARAMETRES TO RECHERCHE;


create table RECHERCHE.NOMENCLATURE_NOMENCLATURES
(
  ID NUMBER NOT NULL,
  STR_ID VARCHAR2(255) NOT NULL,
  LIBELLE VARCHAR2(255) NOT NULL,
  DESCRIPTION VARCHAR2(255),
  -- NN_VISIBLE NUMBER(1) NOT NULL,
  TYPE_NOMENCLATURE VARCHAR2(10) NOT NULL,
  TYPE_VALEURS VARCHAR2(10) NOT NULL,
  PERS_ID_CREATION NUMBER NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL,
  D_CREATION DATE NOT NULL,
  D_MODIFICATION DATE NOT NULL,
  VALID NUMBER(1) DEFAULT 1 NOT NULL,
  MODIFIABLE NUMBER(1) DEFAULT 1 NOT NULL,
  COMPLETABLE NUMBER(1) DEFAULT 1 NOT NULL
);

ALTER TABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

create table RECHERCHE.NOMENCLATURE_OBJETS
(
  ID NUMBER NOT NULL,
  NOMENCLATURE_ID NUMBER NOT NULL,
  CODE VARCHAR2(255),
  LIBELLE_COURT VARCHAR2(255),
  LIBELLE_COURT_CUSTOM VARCHAR2(255),
  LIBELLE_LONG VARCHAR2(255),
  LIBELLE_LONG_CUSTOM VARCHAR2(255),
  VALEUR VARCHAR2(255),
  DATE_DEBUT_VALIDITE DATE NOT NULL,
  DATE_FIN_VALIDITE DATE,
  POSITION NUMBER NOT NULL,
  PERS_ID_CREATION NUMBER NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL,
  D_CREATION DATE NOT NULL,
  D_MODIFICATION DATE NOT NULL,
  VISIBLE NUMBER(1) DEFAULT 1 NOT NULL,
  PERSONNALISEE NUMBER(1) DEFAULT 0 NOT NULL,
  ORIGINE VARCHAR2(1) DEFAULT 'E' NOT NULL
);

ALTER TABLE RECHERCHE.NOMENCLATURE_OBJETS ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.NOMENCLATURE_OBJETS ADD (
  CONSTRAINT FK_NO_NN 
  FOREIGN KEY (NOMENCLATURE_ID) 
  REFERENCES RECHERCHE.NOMENCLATURE_NOMENCLATURES (ID) DEFERRABLE INITIALLY DEFERRED
);




create or replace PROCEDURE RECHERCHE.INS_NOMENCLATURE (
    STR_ID RECHERCHE.NOMENCLATURE_NOMENCLATURES.STR_ID%TYPE,
    LIBELLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.LIBELLE%TYPE,
    DESCRIPTION RECHERCHE.NOMENCLATURE_NOMENCLATURES.DESCRIPTION%TYPE,
    TYPE_NOMENCLATURE RECHERCHE.NOMENCLATURE_NOMENCLATURES.TYPE_NOMENCLATURE%TYPE,
    TYPE_VALEURS RECHERCHE.NOMENCLATURE_NOMENCLATURES.TYPE_VALEURS%TYPE,
    VALID RECHERCHE.NOMENCLATURE_NOMENCLATURES.VALID%TYPE,
    MODIFIABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.MODIFIABLE%TYPE,
    COMPLETABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.COMPLETABLE%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------
gc_persid INTEGER;
-- ---------
-- PRINCIPAL
-- ---------
BEGIN

select pers_id  into gc_persid from grhum.grhum_parametres gp 
  inner join grhum.compte c on gp.param_value = c.cpt_login
    where param_key = 'GRHUM_CREATEUR' and rownum = 1;
  
INSERT
INTO RECHERCHE.NOMENCLATURE_NOMENCLATURES
  (
    ID,
    STR_ID,
    LIBELLE,
    DESCRIPTION,
    TYPE_NOMENCLATURE,
    TYPE_VALEURS,
    PERS_ID_CREATION,
    PERS_ID_MODIFICATION,
    D_CREATION,
    D_MODIFICATION,
    VALID,
    MODIFIABLE,
    COMPLETABLE
  )
  VALUES
  (
    RECHERCHE.NOMENCLATURE_NOMENCLATURES_SEQ.NEXTVAL,
    STR_ID,
    LIBELLE,
    DESCRIPTION,
    TYPE_NOMENCLATURE,
    TYPE_VALEURS,
    gc_persid,
    gc_persid,
    sysdate,
    sysdate,
    VALID,
    MODIFIABLE,
    COMPLETABLE
  );

END;
/

create or replace PROCEDURE RECHERCHE.INS_NOMENCLATURE_OBJET ( 
    NOMENCLATURE_STR_ID RECHERCHE.NOMENCLATURE_NOMENCLATURES.STR_ID%TYPE,
    CODE RECHERCHE.NOMENCLATURE_OBJETS.CODE%TYPE,
    LIBELLE_COURT RECHERCHE.NOMENCLATURE_OBJETS.LIBELLE_COURT%TYPE,
    LIBELLE_LONG RECHERCHE.NOMENCLATURE_OBJETS.LIBELLE_LONG%TYPE,
    VALEUR RECHERCHE.NOMENCLATURE_OBJETS.VALEUR%TYPE,
    DATE_DEBUT_VALIDITE RECHERCHE.NOMENCLATURE_OBJETS.DATE_DEBUT_VALIDITE%TYPE,
    DATE_FIN_VALIDITE RECHERCHE.NOMENCLATURE_OBJETS.DATE_FIN_VALIDITE%TYPE,
    VISIBLE RECHERCHE.NOMENCLATURE_OBJETS.VISIBLE%TYPE,
    PERSONNALISEE RECHERCHE.NOMENCLATURE_OBJETS.PERSONNALISEE%TYPE,
    ORIGINE RECHERCHE.NOMENCLATURE_OBJETS.ORIGINE%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------

gc_persid INTEGER;
nomenclature_id INTEGER;
count_objets INTEGER;
position INTEGER;
-- ---------
-- PRINCIPAL
-- ---------

BEGIN 
 
select pers_id  into gc_persid from grhum.grhum_parametres gp 
  inner join grhum.compte c on gp.param_value = c.cpt_login
    where param_key = 'GRHUM_CREATEUR' and rownum = 1;

select id into nomenclature_id from RECHERCHE.nomenclature_nomenclatures where str_id = NOMENCLATURE_STR_ID;

select count(*) into count_objets from RECHERCHE.nomenclature_objets where nomenclature_id = nomenclature_id;

if(count_objets = 0) THEN
  position := 0;
else
  select max(position) into position from RECHERCHE.nomenclature_objets where nomenclature_id = nomenclature_id;
end if;

INSERT
INTO RECHERCHE.NOMENCLATURE_OBJETS
  (
    ID,
    NOMENCLATURE_ID,
    CODE,
    LIBELLE_COURT,
    LIBELLE_COURT_CUSTOM,
    LIBELLE_LONG,
    LIBELLE_LONG_CUSTOM,
    VALEUR,
    DATE_DEBUT_VALIDITE,
    DATE_FIN_VALIDITE,
    POSITION,
    PERS_ID_CREATION,
    PERS_ID_MODIFICATION,
    D_CREATION,
    D_MODIFICATION,
    VISIBLE,
    PERSONNALISEE,
    ORIGINE
  )
  VALUES
  (
    RECHERCHE.NOMENCLATURE_OBJETS_SEQ.NEXTVAL,
    nomenclature_id,
    CODE,
    LIBELLE_COURT,
    null,
    LIBELLE_LONG,
    null,
    VALEUR,
    DATE_DEBUT_VALIDITE,
    DATE_FIN_VALIDITE,
    position,
    gc_persid,
    gc_persid,
    sysdate,
    sysdate,
    VISIBLE,
    PERSONNALISEE,
    ORIGINE
  );


END;
/

 

